// FileFunc.cpp : t@C֘Å֐

#include <windows.h>
#include <stdlib.h>
#include <tchar.h>

#include "FileFunc.h"
#include "pecmd.h" 		// ꉞinclude (NULLTEXTgp)

TCHAR INI[MAX_PATH + 1] = TEXT("./pecmd.ini");
TCHAR uNxPath[11], ulPath[_MAX_DIR + _MAX_FNAME + _MAX_EXT + 1], ufFilePath[MAX_PATH + 1], uaFilePath1[MAX_PATH + 1], uaFilePath2[MAX_PATH + 1], uaFilePath3[MAX_PATH + 1], uaFilePath4[MAX_PATH + 1], uaFilePath5[MAX_PATH + 1], uaFilePath6[MAX_PATH + 1], uaFilePath7[MAX_PATH + 1], uaFilePath8[MAX_PATH + 1], uaFilePath9[MAX_PATH + 1];
TCHAR szSysDir[MAX_PATH + 1], szWinDir[MAX_PATH + 1];

// t@C̑݊mF
BOOL FileExist(LPCTSTR lpFileName)
{
	BOOL bResult;
	WIN32_FIND_DATA wfd;
	
	HANDLE hFile = FindFirstFile(lpFileName, &wfd);
	
	if (hFile == INVALID_HANDLE_VALUE) {
		bResult = FALSE;
	} else {
		bResult = TRUE;
	}
	
	FindClose(hFile);
	
	return bResult;
}

// t@CI_CAO
BOOL FileOpenDialog(HWND hWnd, LPCTSTR szFilter, LPCTSTR szDefExt, TCHAR *szFilePath)
{
	OPENFILENAME ofn;
	ZeroMemory(&ofn, sizeof(OPENFILENAME));		// ŏɃ[NAĂ
	ofn.lStructSize = sizeof(ofn);				// \̂̃TCY
	ofn.hwndOwner = hWnd;						// R_CAO̐eEBhEnh
	ofn.lpstrFilter = szFilter; 				// t@C̎
	ofn.lpstrFile = szFilePath;					// Iꂽt@C(tpX)󂯎ϐ̃AhX
	ofn.nMaxFile = MAX_PATH;					// lpstrFileɎw肵ϐ̃TCY
	ofn.Flags = OFN_HIDEREADONLY | OFN_CREATEPROMPT;	// tOw
	ofn.lpstrDefExt = szDefExt;					// ftHg̃t@C̎
	
	if (!GetOpenFileName(&ofn)) {
		return FALSE;
	} else {
		return TRUE;
	}
}

// t@Cs (ShellExecute֐̈Ɠ)
HINSTANCE Execute(HWND hWnd, LPCTSTR lpVerb, LPCTSTR lpFile, LPCTSTR lpParameters, LPCTSTR lpDirectory, int nShow)
{
	SHELLEXECUTEINFO sei; 
	ZeroMemory(&sei, sizeof(SHELLEXECUTEINFO));		// [NA
	sei.cbSize = sizeof(SHELLEXECUTEINFO);			// \̃TCY
	sei.fMask = SEE_MASK_INVOKEIDLIST;				//
	sei.hwnd = hWnd;								// EBhEnh
	sei.lpVerb = lpVerb;							// 
	sei.lpFile = lpFile;							// t@C
	sei.lpParameters = lpParameters;				// p[^[
	sei.lpDirectory = lpDirectory;					// Current Directory
	sei.nShow = nShow;								// \
	ShellExecuteEx(&sei);

	return sei.hInstApp;
}

// init@Cf[^̓ǂݏo (G[Ȃ)
void LoadIniData(void)
{
	// ZNV
	TCHAR section[6] = TEXT("pecmd");
	
	// L[f[^̓ǂݏo
	GetPrivateProfileString(section, TEXT("usbpath"), NULLTEXT, uNxPath, sizeof(uNxPath), INI);
	GetPrivateProfileString(section, TEXT("usblaunch"), NULLTEXT, ulPath, sizeof(ulPath), INI);
	GetPrivateProfileString(section, TEXT("userfiler"), NULLTEXT, ufFilePath, sizeof(ufFilePath), INI);
	GetPrivateProfileString(section, TEXT("userapps1"), NULLTEXT, uaFilePath1, sizeof(uaFilePath1), INI);
	GetPrivateProfileString(section, TEXT("userapps2"), NULLTEXT, uaFilePath2, sizeof(uaFilePath2), INI);
	GetPrivateProfileString(section, TEXT("userapps3"), NULLTEXT, uaFilePath3, sizeof(uaFilePath3), INI);
	GetPrivateProfileString(section, TEXT("userapps4"), NULLTEXT, uaFilePath4, sizeof(uaFilePath4), INI);
	GetPrivateProfileString(section, TEXT("userapps5"), NULLTEXT, uaFilePath5, sizeof(uaFilePath5), INI);
	GetPrivateProfileString(section, TEXT("userapps6"), NULLTEXT, uaFilePath6, sizeof(uaFilePath6), INI);
	GetPrivateProfileString(section, TEXT("userapps7"), NULLTEXT, uaFilePath7, sizeof(uaFilePath7), INI);
	GetPrivateProfileString(section, TEXT("userapps8"), NULLTEXT, uaFilePath8, sizeof(uaFilePath8), INI);
	GetPrivateProfileString(section, TEXT("userapps9"), NULLTEXT, uaFilePath9, sizeof(uaFilePath9), INI);

	// 
	CharLower(uNxPath);
}

// t@CpXt@C̖Ô݂o
int FilePathToFileName(LPCTSTR lpFilePath, TCHAR *lpFileName)
{
	TCHAR szDrive[_MAX_DRIVE+1];
	TCHAR szDir[_MAX_DIR+1];
	TCHAR szFname[_MAX_FNAME+1];
	TCHAR szExt[_MAX_EXT+1];
	
	// pX𕪉
	_tsplitpath_s(lpFilePath, szDrive, sizeof(szDrive), szDir, sizeof(szDir), szFname, sizeof(szFname), szExt, sizeof(szExt));
	
	// t@C(gq)𐶐
	lstrcpy(lpFileName, szFname);
	lstrcat(lpFileName, szExt);
	
	// 
	CharLower(lpFileName);
	
	return 0;
	
}

// VXefBNg擾
void GetSysDir(void)
{
	GetSystemDirectory(szSysDir, MAX_PATH);
	GetWindowsDirectory(szWinDir, MAX_PATH);
}
